Index: trunk/src/world_entities/projectiles/acid_splash.cc
===================================================================
--- trunk/src/world_entities/projectiles/acid_splash.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/acid_splash.cc	(revision 10698)
@@ -116,6 +116,6 @@
   this->toList(OM_NULL);
   //this->toList(OM_DEAD);
-  this->removeNode();
-  
+//   this->removeNode();
+
   AcidSplash::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/hbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/hbolt.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/hbolt.cc	(revision 10698)
@@ -46,5 +46,5 @@
   this->setMinEnergy(10);
   this->setHealthMax(0);
-  this->lifeSpan = 2.0;
+  this->lifeSpan = 3.0;
 
   this->angle = 0;
@@ -116,5 +116,5 @@
 
   this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   HBolt::fastFactory->kill(this);
 
@@ -177,5 +177,5 @@
   glPushAttrib(GL_ENABLE_BIT);
   glDisable(GL_LIGHTING);
-//   glDisable(GL_FOG);
+  glDisable(GL_FOG);
 
   glMatrixMode(GL_MODELVIEW);
@@ -184,4 +184,6 @@
 //     float matrix[4][4];
     glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+    this->halo->draw();
+
     Vector tmpRot = this->getAbsDir().getSpacialAxis();
     glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
@@ -189,5 +191,4 @@
 //     glMultMatrixf((float*)matrix);
     this->getModel()->draw();
-    this->halo->draw();
 
   glPopMatrix();
Index: trunk/src/world_entities/projectiles/laser.cc
===================================================================
--- trunk/src/world_entities/projectiles/laser.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/laser.cc	(revision 10698)
@@ -100,5 +100,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   Laser::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/lbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/lbolt.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/lbolt.cc	(revision 10698)
@@ -62,7 +62,8 @@
   this->halo = new Billboard();
   this->halo->setSize(.35, .35);
-  this->halo->setTexture("hbolt_halo.png");
+  this->halo->setTexture("hbolt_halo.jpg");
   this->halo->setVisibility(false);
 
+  this->halo->setPulse();
 
 }
@@ -120,5 +121,5 @@
 
   this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   LBolt::fastFactory->kill(this);
 }
@@ -148,4 +149,6 @@
 
   angle += LBolt::rotationSpeed * dt;
+  if(angle > 360)
+    angle -= 360;
 
   for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
@@ -183,13 +186,16 @@
     float matrix[4][4];
     glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
-    Vector tmpRot = this->getAbsDir().getSpacialAxis();
+    this->halo->draw();
+
+    Vector tmpRot;
+    tmpRot = this->flightDirection.getNormalized();
+    glRotatef(this->angle, tmpRot.x, tmpRot.y, tmpRot.z);
+    tmpRot = this->getAbsDir().getSpacialAxis();
     glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-    glRotatef(this->angle, 1.0, 0.0, 0.0);
+
     this->getAbsDir().matrix (matrix);
     glMultMatrixf((float*)matrix);
     this->getModel()->draw();
 
-    this->halo->draw();
-
   glPopMatrix();
   glPopAttrib();
Index: trunk/src/world_entities/projectiles/mbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/mbolt.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/mbolt.cc	(revision 10698)
@@ -145,5 +145,5 @@
   this->toList(OM_NULL);
   //this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   MBolt::fastFactory->kill(this);
 }
@@ -212,5 +212,6 @@
   float matrix[4][4];
   glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
-  glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile
+//   glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile
+  glRotatef(this->angle, this->flightDirection.x, this->flightDirection.y, this->flightDirection.z);
   this->getAbsDir().matrix (matrix);
   glMultMatrixf((float*)matrix);
Index: trunk/src/world_entities/projectiles/nadion_blast.cc
===================================================================
--- trunk/src/world_entities/projectiles/nadion_blast.cc	(revision 10698)
+++ trunk/src/world_entities/projectiles/nadion_blast.cc	(revision 10698)
@@ -0,0 +1,231 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer
+   co-programmer: Benjamin Grauer
+
+*/
+
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "nadion_blast.h"
+
+#include "state.h"
+#include "model.h"
+
+#include "world_entities/npcs/npc.h"
+
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
+
+#include "space_ships/space_ship.h"
+
+#include <cassert>
+#include "debug.h"
+
+#include "static_model.h"
+
+#include "effects/trail.h"
+
+
+
+ObjectListDefinition(NadionBlast);
+CREATE_FAST_FACTORY_STATIC(NadionBlast);
+
+/**
+ *  standard constructor
+*/
+NadionBlast::NadionBlast () : Projectile()
+{
+  this->registerObject(this, NadionBlast::_objectList);
+  this->loadModel("models/projectiles/mbolt.obj",4);
+
+
+  //this->loadModel("models/projectiles/laser.obj");
+
+  this->setMinEnergy(4);
+  this->setHealthMax(0);
+  this->lifeSpan = 2.5;
+  this->angle     = 0;
+
+  //this->emitter = new DotEmitter(1000, 0, 0);
+  this->emitter = new DotEmitter(50, 0, 0);
+  this->emitter->setParent(this);
+  this->emitter->setSpread(M_PI,M_PI);
+  this->emitter->setInheritSpeed(this->velocity.len());
+  this->emitter->setEmissionRate(500.0);
+  this->emitter->setEmissionVelocity(this->velocity.len());
+
+  this->mat = new Material("NadionBlast");
+  //this->mat->setBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
+  this->mat->setBlendFunc(GL_SRC_ALPHA,GL_ONE);
+  this->mat->setDiffuse(1,1,1);
+  this->mat->setDiffuseMap("laser_add.png");
+  this->mat->setDiffuseMap("laser2.png",1);
+
+  dynamic_cast<StaticModel*>(this->getModel())->addMaterial(*this->mat);
+  dynamic_cast<StaticModel*>(this->getModel())->finalize();
+
+  dynamic_cast<StaticModel*>(this->getModel())->rebuild();
+  //this->buildObbTree(4);
+
+//   this->trail = new Trail(6, 4, .1, this);
+  //this->trail->setParent( this);
+//   this->trail->setTexture( "textures/laser.png");
+//   this->trail->setAbsCoor(this->getAbsCoor() - Vector(.7,0,0));
+//   this->trail->setAbsCoor(this->getAbsCoor() - this->getVelocity().getNormalized() * .7);
+
+}
+
+
+/**
+ *  standard deconstructor
+ *
+ */
+NadionBlast::~NadionBlast ()
+{
+
+  if (NadionBlast::explosionParticles != NULL && NadionBlast::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(NadionBlast::explosionParticles))
+      delete NadionBlast::explosionParticles;
+    NadionBlast::explosionParticles = NULL;
+    PRINTF(1)("Deleting NadionBlast Explosion Particles\n");
+  }
+
+  delete this->emitter;
+//   delete this->trail;
+}
+
+SpriteParticles* NadionBlast::explosionParticles = NULL;
+
+void NadionBlast::activate()
+{
+  this->origList = this->getOMListNumber();
+  this->toList(OM_ENVIRON);
+  if (unlikely(NadionBlast::explosionParticles == NULL))
+  {
+    NadionBlast::explosionParticles = new SpriteParticles(1000);
+    NadionBlast::explosionParticles->setName("NadionBlastExplosionParticles");
+    NadionBlast::explosionParticles->setLifeSpan(.2, .1);
+    NadionBlast::explosionParticles->setRadius(0.0, 10.0);
+    NadionBlast::explosionParticles->setRadius(.5, 6.0);
+    NadionBlast::explosionParticles->setRadius(1.0, 3.0);
+    NadionBlast::explosionParticles->setColor(0.0, 1,1,0,.9);
+    NadionBlast::explosionParticles->setColor(0.5, .8,.8,0,.5);
+    NadionBlast::explosionParticles->setColor(1.0, .8,.8,.7,.0);
+  }
+
+  this->setPhysDamage(10);
+  this->setElecDamage(0);
+  this->setHealth(0);
+
+  this->emitter->setSpread(0);
+  this->emitter->setEmissionRate(10.0);
+  this->emitter->setEmissionVelocity(50);
+}
+
+
+void NadionBlast::deactivate()
+{
+  assert (NadionBlast::explosionParticles != NULL);
+  NadionBlast::explosionParticles->removeEmitter(this->emitter);
+  this->lifeCycle = 0.0;
+
+  this->lifeCycle = 0.0;
+  this->toList(OM_NULL);
+  //this->toList(OM_DEAD);
+//   this->removeNode();
+  NadionBlast::fastFactory->kill(this);
+}
+
+/*
+void NadionBlast::hit (float damage, WorldEntity* entity )
+{
+
+  if (this->hitEntity != entity)
+    this->destroy( entity );
+  this->hitEntity = entity;
+ // dynamic_cast<SpaceShip*>(entity)->damage(this->getPhysDamage(),this->getElecDamage());
+  //this->destroy(this);
+  this->deactivate();
+
+  return;
+
+}*/
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param dt time since last tick
+*/
+void NadionBlast::tick (float dt)
+{
+  //Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.1);
+  Vector v = this->velocity * dt;
+  this->shiftCoor(v);
+
+  if (this->tickLifeCycle(dt))
+    this->deactivate();
+
+  this->angle += NadionBlast::rotationSpeed * dt;
+//   this->trail->tick(dt);
+
+  for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
+    {
+      (*eIterator)->destroy(this); //hit (this->getDamage(),this);
+      this->deactivate();
+      PRINTF(0)("NadionBlast destroyed\n");
+    }
+  }
+}
+
+/**
+ *  the function gets called, when the projectile is destroyed
+*/
+void NadionBlast::destroy (WorldEntity* killer)
+{
+  //this->deactivate();
+  Projectile::destroy( killer );
+  PRINTF(5)("DESTROY NadionBlast\n");
+  this->lifeCycle = .95; //!< @todo calculate this usefully.
+
+  this->emitter->setSystem(NadionBlast::explosionParticles);
+}
+
+
+void NadionBlast::draw () const
+{
+  glPushAttrib(GL_ENABLE_BIT);
+  glDisable(GL_LIGHTING);
+
+  glPushMatrix();
+  float matrix[4][4];
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+//   glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile
+  glRotatef(this->angle, this->flightDirection.x, this->flightDirection.y, this->flightDirection.z);
+  this->getAbsDir().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+
+  glScalef(0.75/6, 0.7/16, 0.7/16);  // no double rescale
+
+  this->mat->select();
+  dynamic_cast<StaticModel*>(this->getModel())->draw();
+  this->mat->unselect();
+//   glScalef(4/.75,16/.7,16/.7);
+//   glTranslatef(-3,0,0);
+//   this->trail->draw();
+  glPopMatrix();
+  glPopAttrib();
+
+}
Index: trunk/src/world_entities/projectiles/nadion_blast.h
===================================================================
--- trunk/src/world_entities/projectiles/nadion_blast.h	(revision 10698)
+++ trunk/src/world_entities/projectiles/nadion_blast.h	(revision 10698)
@@ -0,0 +1,54 @@
+/*!
+ * @file nadion_blast.h
+ * @brief nadion blast
+*/
+
+#ifndef _NADION_BLAST_H
+#define _NADION_BLAST_H
+
+#include "projectile.h"
+#include "material.h"
+
+class Vector;
+class Weapon;
+class SpriteParticles;
+class ParticleEmitter;
+class FastFactory;
+class Trail;
+
+class NadionBlast : public Projectile
+{
+  ObjectListDeclaration(NadionBlast);
+  public:
+    NadionBlast ();
+    virtual ~NadionBlast ();
+
+
+    virtual void activate();
+    virtual void deactivate();
+
+//     virtual void hit (float damage, WorldEntity* entity);
+
+    virtual void destroy (WorldEntity* killer);
+
+    virtual void tick (float dt);
+    virtual void draw () const;
+
+  private:
+    static FastFactory*               fastFactory;
+    static SpriteParticles*           explosionParticles;
+
+//     Trail*                            trail;
+
+    float                             angle;
+    static const float                rotationSpeed = 1080;
+
+    ParticleEmitter*                  emitter;
+
+    Material*                         mat;
+
+
+//     WorldEntity* hitEntity; // FIXME TEMPORARY
+};
+
+#endif /* _NADION_BLAST_H */
Index: trunk/src/world_entities/projectiles/plasma_pulse.cc
===================================================================
--- trunk/src/world_entities/projectiles/plasma_pulse.cc	(revision 10698)
+++ trunk/src/world_entities/projectiles/plasma_pulse.cc	(revision 10698)
@@ -0,0 +1,146 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer
+   co-programmer: Benjamin Grauer, Nicolas Schlumberger
+
+*/
+
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "plasma_pulse.h"
+
+#include "state.h"
+
+#include <cassert>
+#include "debug.h"
+
+
+ObjectListDefinition(PlasmaPulse);
+CREATE_FAST_FACTORY_STATIC(PlasmaPulse);
+
+/**
+ *  standard constructor
+*/
+PlasmaPulse::PlasmaPulse () : Projectile()
+{
+  this->registerObject(this, PlasmaPulse::_objectList);
+
+
+  this->setMinEnergy(1);
+  this->setHealthMax(0);
+  this->lifeSpan = 2.0;
+
+  this->grid = new Billboard();
+  this->grid->setSize(.2, .2);
+  this->grid->setPulseMagnitude(.8);
+  this->grid->setParent(this);
+  this->grid->setVisibility(false);
+  this->grid->setPulse();
+  this->grid->setTexture( "textures/plasma.png");
+  this->grid->toList(OM_ENVIRON);
+/*
+  this->blink = new Blink();
+  this->grid->setParent(this);
+  this->grid->setVisibility(false);
+  this->blink->setSize(1.0 );
+  this->blink->setPeriod(.4);
+  this->blink->setColor(10, 250, 150);
+  this->blink->loadBlinkSequence( "66678998766" );
+  this->blink->toList(OM_ENVIRON);*/
+}
+
+
+/**
+ *  standard deconstructor
+ *
+ */
+PlasmaPulse::~PlasmaPulse ()
+{
+  this->grid->toList(OM_DEAD);
+//   this->blink->toList(OM_DEAD);
+}
+
+
+void PlasmaPulse::activate()
+{
+  this->origList = this->getOMListNumber();
+  this->toList(OM_ENVIRON);
+  this->grid->setVisibility(true);
+//   this->blink->setVisibility(true);
+
+  this->setPhysDamage(10);
+  this->setElecDamage(0);
+  this->setHealth(0);
+}
+
+
+void PlasmaPulse::deactivate()
+{
+  this->lifeCycle = 0.0;
+
+  this->grid->setVisibility(false);
+//   this->blink->setVisibility(false);
+  this->lifeCycle = 0.0;
+  this->toList(OM_NULL);
+//   this->removeNode();
+
+  PlasmaPulse::fastFactory->kill(this);
+}
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param dt time since last tick
+*/
+void PlasmaPulse::tick (float dt)
+{
+  Vector v = this->velocity * dt;
+  this->shiftCoor(v);
+
+  if (this->tickLifeCycle(dt))
+    this->deactivate();
+
+  this->grid->tick(dt);
+
+  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
+  {
+    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 3)
+    {
+      (*eIterator)->hit (this->getDamage(),this);
+      this->deactivate();
+    }
+  }
+
+}
+
+/**
+ *  the function gets called, when the projectile is destroyed
+*/
+void PlasmaPulse::destroy (WorldEntity* killer)
+{
+  this->deactivate();
+  Projectile::destroy( killer );
+  PRINTF(5)("DESTROY PlasmaPulse\n");
+  this->lifeCycle = .95; //!< @todo calculate this usefully.
+}
+
+
+void PlasmaPulse::draw () const
+{
+  glPushMatrix();
+    glEnable( GL_ALPHA_TEST);
+    glAlphaFunc( GL_GEQUAL, .5);
+    this->grid->draw();
+//     this->blink->draw();
+  glPopMatrix();
+
+}
Index: trunk/src/world_entities/projectiles/plasma_pulse.h
===================================================================
--- trunk/src/world_entities/projectiles/plasma_pulse.h	(revision 10698)
+++ trunk/src/world_entities/projectiles/plasma_pulse.h	(revision 10698)
@@ -0,0 +1,39 @@
+/*!
+ * @file plasma_pulse.h
+ * @brief Pulsing Plasma projectile
+*/
+
+#ifndef _PLASMAPULSE_H
+#define _PLASMAPULSE_H
+
+#include "projectile.h"
+#include "effects/billboard.h"
+#include "effects/blink.h"
+
+class Vector;
+class Weapon;
+class FastFactory;
+class Wobblegrid;
+
+class PlasmaPulse : public Projectile
+{
+  ObjectListDeclaration(PlasmaPulse);
+  public:
+    PlasmaPulse ();
+    virtual ~PlasmaPulse ();
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void destroy (WorldEntity* killer);
+
+    virtual void tick (float dt);
+    virtual void draw () const;
+
+  private:
+    static FastFactory*               fastFactory;
+    Billboard*                        grid;
+//     Blink*                            blink;
+};
+
+#endif /* _PLASMAPULSE_H */
Index: trunk/src/world_entities/projectiles/rail_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 10698)
@@ -99,5 +99,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   RailProjectile::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/spike.cc
===================================================================
--- trunk/src/world_entities/projectiles/spike.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/spike.cc	(revision 10698)
@@ -111,5 +111,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   Spike::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/spike_ball.cc
===================================================================
--- trunk/src/world_entities/projectiles/spike_ball.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/spike_ball.cc	(revision 10698)
@@ -149,5 +149,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   SpikeBall::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/swarm_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/swarm_projectile.cc	(revision 10618)
+++ trunk/src/world_entities/projectiles/swarm_projectile.cc	(revision 10698)
@@ -134,5 +134,5 @@
 
   this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   SwarmProjectile::fastFactory->kill(this);
 }
@@ -200,9 +200,6 @@
     this->deactivate();
 
-
-
 /** old  guiding function*/
-
-  float projectileVelocity = this->getVelocity().len();
+  static float projectileVelocity = this->getVelocity().len();
   if (target != NULL){
     Vector estTargetDir = (this->target->getAbsCoor() - this->getAbsCoor()).getNormalized();
@@ -225,9 +222,5 @@
 
   this->angle += this->rotationSpeed * time;
-
-  while (this->angle > 360)
-  {
-    this->angle -= 360;
-  }
+  while (this->angle > 360) { this->angle -= 360; }
 
   this->lastDir = this->curDir;
@@ -240,5 +233,5 @@
     PRINTF(0)("Target was hit by Swarm Missile!\n");
   }
-  else if( this->target == NULL)
+  if( this->target == NULL)
     this->deactivate();
 }
